#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <openssl/ssl.h>
#include <openssl/bio.h>
#include <openssl/err.h>

#define PORT 2053

static int
makesock(int port)
{
	/* voir en annexe */
}

int
main()
{
	SSL_library_init();
	SSL_load_error_strings();

	int sock = makesock(PORT);

	BIO* conn = BIO_new_dgram(sock, BIO_NOCLOSE);
	if (conn == NULL) {
		fprintf(stderr,"error creating bio\n");
		return 1;
	} /*@ \label{dc:endk} @*/

	struct sockaddr_in dst; /*@ \label{dc:dst:beg} @*/
	struct sockaddr* d = (struct sockaddr*) &dst;
#ifndef __GLIBC__
	dst.sin_len = sizeof(struct sockaddr_in);
#endif
	dst.sin_family = AF_INET;
	dst.sin_port = htons(PORT);
	dst.sin_addr.s_addr = htonl(INADDR_LOOPBACK);  /*@ \label{dc:dst:end} @*/

	int err = BIO_dgram_set_peer(conn, d); /*@ \label{dc:dst:peer} @*/
	fprintf(stderr, "BIO_dgram_set_peer: %d\n", err);

	SSL_CTX *ctx = SSL_CTX_new(DTLSv1_client_method());
	if (ctx == NULL) {
		ERR_print_errors_fp(stderr);
		return 2;
	}
	SSL_CTX_set_read_ahead(ctx, 1);
	SSL_CTX_set_cipher_list(ctx, "HIGH:MEDIUM:aNULL");

	SSL *ssl = SSL_new(ctx);
	if (ssl == NULL) {
		return 3;
	}

	SSL_set_bio(ssl, conn, conn);
	SSL_set_connect_state(ssl);/*@ \label{dc:connect} @*/

	char *c = "Hello, enciphered World!\n";
	err = SSL_write(ssl, c, strlen(c));
	if (err <= 0) {
		err = SSL_get_error(ssl, err);
		fprintf(stderr, "SSL_write: error %d\n", err);
		ERR_print_errors_fp(stderr);
		if (err == SSL_ERROR_SYSCALL)
			fprintf(stderr, "errno: %s\n", strerror(errno));
	}

	char buf[256] = {0};
	err = SSL_read(ssl, buf, 256);
	if (err <= 0) {
		err = SSL_get_error(ssl, err);
		fprintf(stderr, "SSL_read: error %d\n", err);
		ERR_print_errors_fp(stderr);
		if (err == SSL_ERROR_SYSCALL)
			fprintf(stderr, "errno: %s\n", strerror(errno));
	}
	fprintf(stderr, "%s\n", buf);

	SSL_free(ssl); /* free conn too */
	SSL_CTX_free(ctx);
	close(sock);
	return 0;
}
