#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

#include <openssl/ssl.h>
#include <openssl/err.h>

#include "dtlsplex.h"

#define PORT 2053

static int
makesock(void)
{
	int sock = 0;
/*	struct sockaddr_in6 addr;
	addr.sin6_addr = in6addr_any;*/
	struct sockaddr_in addr;
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	addr.sin_port = htons(PORT);

	sock = socket(PF_INET, SOCK_DGRAM, 0);
	if (sock < 0) {
		fprintf(stderr, "socket: %s\n", strerror(errno));
		exit (1);
	}

//	freeaddrinfo(oaddr_list);

	return sock;
}

int
main()
{
	SSL_library_init();
	SSL_load_error_strings();

	int sock = makesock();

	struct sockaddr_in dst;
	struct sockaddr* d = (struct sockaddr*) &dst;
#ifndef __GLIBC__
	dst.sin_len = sizeof(struct sockaddr_in);
#endif
	dst.sin_family = AF_INET;
	dst.sin_port = htons(PORT);
	dst.sin_addr.s_addr = htonl(INADDR_LOOPBACK);

	int ret;

	char buf[256] = {0};
	struct sockaddr_storage s;
	socklen_t slen = 0;

	do {
		char ch[] = "Hello, enciphered World!\n";
		int l = strlen(ch);
		ret = dtlssendto(sock, ch, l, 0, d, sizeof dst);
		if (ret < 0)
			fprintf(stderr, "dtlssendto returned %d\n", ret);
		int ret2 = dtlsrecvfrom(sock, buf, 256, 0,
					(struct sockaddr*) &s, &slen);
		fprintf(stderr, "dtlsrecvfrom returned %d\n", ret2);
		if (ret2 > 0)
			fprintf(stderr, "%s\n", buf);
	} while (ret == 0);

	int ret2 = dtlsrecvfrom(sock, buf, 256, 0,
				(struct sockaddr*) &s, &slen);
	fprintf(stderr, "dtlsrecvfrom returned %d\n", ret2);
	if (ret2 > 0)
		fprintf(stderr, "%s\n", buf);

	return 0;
}
