#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

#include <openssl/ssl.h>
#include <openssl/bio.h>
#include <openssl/err.h>

#include "dtlsplex.h"

#define PORT 2053

static int
makesock(void)
{
	int sock = 0;
/*	struct sockaddr_in6 addr;
	addr.sin6_addr = in6addr_any;*/
	struct sockaddr_in addr;
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	addr.sin_port = htons(PORT);

	sock = socket(PF_INET, SOCK_DGRAM, 0);
	if (sock < 0) {
		fprintf(stderr, "socket: %s\n", strerror(errno));
		exit (1);
	}

	if (bind(sock, (struct sockaddr*) &addr, sizeof addr)) {
		fprintf(stderr, "bind: %s\n", strerror(errno));
		exit (1);
	}

//	freeaddrinfo(oaddr_list);

	return sock;
}

int
main()
{
	SSL_library_init();
	SSL_load_error_strings();

	int sock = makesock();

	while(1) {
		char buf[256] = {0};
		struct sockaddr_storage s;
		socklen_t slen = 0;
		int ret = dtlsrecvfrom(sock, buf, 256, 0,
				       (struct sockaddr*) &s, &slen);
		fprintf(stderr, "dtlsrecvfrom returned %d\n", ret);
		fprintf(stderr, "%s", buf);

		char ch[] = "Hello Yourself";
		ret = dtlssendto(sock, ch, strlen(ch), 0,
				 (struct sockaddr*) &s, slen);
		fprintf(stderr, "dtlssendto returned %d\n", ret);
	}

	return 0;
}
