/*
 * Misc. network related functions
 *
 * Copyright (c) 2004-2006 Nicolas Bernard
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef _NETMISC_H_
#define _NETMISC_H_

int isloopback(struct sockaddr* addr);
int isprivateip(struct sockaddr* addr);

/** return 0 if IP(a) != IP(b), 1 if IP(a) == IP(b), <0 in case of error */
int addreql(const struct sockaddr* a, const struct sockaddr* b);

/** return 0 if Port(a) != Port(b), 1 if Port(a) == Port(b),
    <0 in case of error */
int porteql(const struct sockaddr* a, const struct sockaddr* b);

int echoip(FILE* f, struct sockaddr* addr);

/** returns the assumed size of the struct sockaddr.
    useful because GLIBC's sockaddr doesn't have a sa_len field */
unsigned int addrsize(struct sockaddr* a);

#endif /* ! _NETMISC_H_ */
